// package: supervisor
// file: control.proto

import * as jspb from "google-protobuf";
import * as status_pb from "./status_pb";
import * as info_pb from "./info_pb";

export class ExposePortRequest extends jspb.Message {
  getPort(): number;
  setPort(value: number): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ExposePortRequest.AsObject;
  static toObject(includeInstance: boolean, msg: ExposePortRequest): ExposePortRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ExposePortRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ExposePortRequest;
  static deserializeBinaryFromReader(message: ExposePortRequest, reader: jspb.BinaryReader): ExposePortRequest;
}

export namespace ExposePortRequest {
  export type AsObject = {
    port: number,
  }
}

export class ExposePortResponse extends jspb.Message {
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ExposePortResponse.AsObject;
  static toObject(includeInstance: boolean, msg: ExposePortResponse): ExposePortResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ExposePortResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ExposePortResponse;
  static deserializeBinaryFromReader(message: ExposePortResponse, reader: jspb.BinaryReader): ExposePortResponse;
}

export namespace ExposePortResponse {
  export type AsObject = {
  }
}

export class CreateSSHKeyPairRequest extends jspb.Message {
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): CreateSSHKeyPairRequest.AsObject;
  static toObject(includeInstance: boolean, msg: CreateSSHKeyPairRequest): CreateSSHKeyPairRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: CreateSSHKeyPairRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): CreateSSHKeyPairRequest;
  static deserializeBinaryFromReader(message: CreateSSHKeyPairRequest, reader: jspb.BinaryReader): CreateSSHKeyPairRequest;
}

export namespace CreateSSHKeyPairRequest {
  export type AsObject = {
  }
}

export class CreateSSHKeyPairResponse extends jspb.Message {
  getPrivateKey(): string;
  setPrivateKey(value: string): void;

  hasHostKey(): boolean;
  clearHostKey(): void;
  getHostKey(): SSHPublicKey | undefined;
  setHostKey(value?: SSHPublicKey): void;

  getUserName(): string;
  setUserName(value: string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): CreateSSHKeyPairResponse.AsObject;
  static toObject(includeInstance: boolean, msg: CreateSSHKeyPairResponse): CreateSSHKeyPairResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: CreateSSHKeyPairResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): CreateSSHKeyPairResponse;
  static deserializeBinaryFromReader(message: CreateSSHKeyPairResponse, reader: jspb.BinaryReader): CreateSSHKeyPairResponse;
}

export namespace CreateSSHKeyPairResponse {
  export type AsObject = {
    privateKey: string,
    hostKey?: SSHPublicKey.AsObject,
    userName: string,
  }
}

export class SSHPublicKey extends jspb.Message {
  getType(): string;
  setType(value: string): void;

  getValue(): string;
  setValue(value: string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): SSHPublicKey.AsObject;
  static toObject(includeInstance: boolean, msg: SSHPublicKey): SSHPublicKey.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: SSHPublicKey, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): SSHPublicKey;
  static deserializeBinaryFromReader(message: SSHPublicKey, reader: jspb.BinaryReader): SSHPublicKey;
}

export namespace SSHPublicKey {
  export type AsObject = {
    type: string,
    value: string,
  }
}

export class CreateDebugEnvRequest extends jspb.Message {
  getWorkspaceType(): info_pb.DebugWorkspaceTypeMap[keyof info_pb.DebugWorkspaceTypeMap];
  setWorkspaceType(value: info_pb.DebugWorkspaceTypeMap[keyof info_pb.DebugWorkspaceTypeMap]): void;

  getContentSource(): status_pb.ContentSourceMap[keyof status_pb.ContentSourceMap];
  setContentSource(value: status_pb.ContentSourceMap[keyof status_pb.ContentSourceMap]): void;

  getWorkspaceUrl(): string;
  setWorkspaceUrl(value: string): void;

  getTasks(): string;
  setTasks(value: string): void;

  getCheckoutLocation(): string;
  setCheckoutLocation(value: string): void;

  getWorkspaceLocation(): string;
  setWorkspaceLocation(value: string): void;

  getLoglevel(): string;
  setLoglevel(value: string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): CreateDebugEnvRequest.AsObject;
  static toObject(includeInstance: boolean, msg: CreateDebugEnvRequest): CreateDebugEnvRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: CreateDebugEnvRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): CreateDebugEnvRequest;
  static deserializeBinaryFromReader(message: CreateDebugEnvRequest, reader: jspb.BinaryReader): CreateDebugEnvRequest;
}

export namespace CreateDebugEnvRequest {
  export type AsObject = {
    workspaceType: info_pb.DebugWorkspaceTypeMap[keyof info_pb.DebugWorkspaceTypeMap],
    contentSource: status_pb.ContentSourceMap[keyof status_pb.ContentSourceMap],
    workspaceUrl: string,
    tasks: string,
    checkoutLocation: string,
    workspaceLocation: string,
    loglevel: string,
  }
}

export class CreateDebugEnvResponse extends jspb.Message {
  clearEnvsList(): void;
  getEnvsList(): Array<string>;
  setEnvsList(value: Array<string>): void;
  addEnvs(value: string, index?: number): string;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): CreateDebugEnvResponse.AsObject;
  static toObject(includeInstance: boolean, msg: CreateDebugEnvResponse): CreateDebugEnvResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: CreateDebugEnvResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): CreateDebugEnvResponse;
  static deserializeBinaryFromReader(message: CreateDebugEnvResponse, reader: jspb.BinaryReader): CreateDebugEnvResponse;
}

export namespace CreateDebugEnvResponse {
  export type AsObject = {
    envsList: Array<string>,
  }
}

