// package: supervisor
// file: status.proto

import * as jspb from "google-protobuf";
import * as port_pb from "./port_pb";

export class SupervisorStatusRequest extends jspb.Message {
  getWillshutdown(): boolean;
  setWillshutdown(value: boolean): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): SupervisorStatusRequest.AsObject;
  static toObject(includeInstance: boolean, msg: SupervisorStatusRequest): SupervisorStatusRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: SupervisorStatusRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): SupervisorStatusRequest;
  static deserializeBinaryFromReader(message: SupervisorStatusRequest, reader: jspb.BinaryReader): SupervisorStatusRequest;
}

export namespace SupervisorStatusRequest {
  export type AsObject = {
    willshutdown: boolean,
  }
}

export class SupervisorStatusResponse extends jspb.Message {
  getOk(): boolean;
  setOk(value: boolean): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): SupervisorStatusResponse.AsObject;
  static toObject(includeInstance: boolean, msg: SupervisorStatusResponse): SupervisorStatusResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: SupervisorStatusResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): SupervisorStatusResponse;
  static deserializeBinaryFromReader(message: SupervisorStatusResponse, reader: jspb.BinaryReader): SupervisorStatusResponse;
}

export namespace SupervisorStatusResponse {
  export type AsObject = {
    ok: boolean,
  }
}

export class IDEStatusRequest extends jspb.Message {
  getWait(): boolean;
  setWait(value: boolean): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): IDEStatusRequest.AsObject;
  static toObject(includeInstance: boolean, msg: IDEStatusRequest): IDEStatusRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: IDEStatusRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): IDEStatusRequest;
  static deserializeBinaryFromReader(message: IDEStatusRequest, reader: jspb.BinaryReader): IDEStatusRequest;
}

export namespace IDEStatusRequest {
  export type AsObject = {
    wait: boolean,
  }
}

export class IDEStatusResponse extends jspb.Message {
  getOk(): boolean;
  setOk(value: boolean): void;

  hasDesktop(): boolean;
  clearDesktop(): void;
  getDesktop(): IDEStatusResponse.DesktopStatus | undefined;
  setDesktop(value?: IDEStatusResponse.DesktopStatus): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): IDEStatusResponse.AsObject;
  static toObject(includeInstance: boolean, msg: IDEStatusResponse): IDEStatusResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: IDEStatusResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): IDEStatusResponse;
  static deserializeBinaryFromReader(message: IDEStatusResponse, reader: jspb.BinaryReader): IDEStatusResponse;
}

export namespace IDEStatusResponse {
  export type AsObject = {
    ok: boolean,
    desktop?: IDEStatusResponse.DesktopStatus.AsObject,
  }

  export class DesktopStatus extends jspb.Message {
    getLink(): string;
    setLink(value: string): void;

    getLabel(): string;
    setLabel(value: string): void;

    getClientid(): string;
    setClientid(value: string): void;

    getKind(): string;
    setKind(value: string): void;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): DesktopStatus.AsObject;
    static toObject(includeInstance: boolean, msg: DesktopStatus): DesktopStatus.AsObject;
    static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
    static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
    static serializeBinaryToWriter(message: DesktopStatus, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): DesktopStatus;
    static deserializeBinaryFromReader(message: DesktopStatus, reader: jspb.BinaryReader): DesktopStatus;
  }

  export namespace DesktopStatus {
    export type AsObject = {
      link: string,
      label: string,
      clientid: string,
      kind: string,
    }
  }
}

export class ContentStatusRequest extends jspb.Message {
  getWait(): boolean;
  setWait(value: boolean): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ContentStatusRequest.AsObject;
  static toObject(includeInstance: boolean, msg: ContentStatusRequest): ContentStatusRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ContentStatusRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ContentStatusRequest;
  static deserializeBinaryFromReader(message: ContentStatusRequest, reader: jspb.BinaryReader): ContentStatusRequest;
}

export namespace ContentStatusRequest {
  export type AsObject = {
    wait: boolean,
  }
}

export class ContentStatusResponse extends jspb.Message {
  getAvailable(): boolean;
  setAvailable(value: boolean): void;

  getSource(): ContentSourceMap[keyof ContentSourceMap];
  setSource(value: ContentSourceMap[keyof ContentSourceMap]): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ContentStatusResponse.AsObject;
  static toObject(includeInstance: boolean, msg: ContentStatusResponse): ContentStatusResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ContentStatusResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ContentStatusResponse;
  static deserializeBinaryFromReader(message: ContentStatusResponse, reader: jspb.BinaryReader): ContentStatusResponse;
}

export namespace ContentStatusResponse {
  export type AsObject = {
    available: boolean,
    source: ContentSourceMap[keyof ContentSourceMap],
  }
}

export class BackupStatusRequest extends jspb.Message {
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): BackupStatusRequest.AsObject;
  static toObject(includeInstance: boolean, msg: BackupStatusRequest): BackupStatusRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: BackupStatusRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): BackupStatusRequest;
  static deserializeBinaryFromReader(message: BackupStatusRequest, reader: jspb.BinaryReader): BackupStatusRequest;
}

export namespace BackupStatusRequest {
  export type AsObject = {
  }
}

export class BackupStatusResponse extends jspb.Message {
  getCanaryAvailable(): boolean;
  setCanaryAvailable(value: boolean): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): BackupStatusResponse.AsObject;
  static toObject(includeInstance: boolean, msg: BackupStatusResponse): BackupStatusResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: BackupStatusResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): BackupStatusResponse;
  static deserializeBinaryFromReader(message: BackupStatusResponse, reader: jspb.BinaryReader): BackupStatusResponse;
}

export namespace BackupStatusResponse {
  export type AsObject = {
    canaryAvailable: boolean,
  }
}

export class PortsStatusRequest extends jspb.Message {
  getObserve(): boolean;
  setObserve(value: boolean): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): PortsStatusRequest.AsObject;
  static toObject(includeInstance: boolean, msg: PortsStatusRequest): PortsStatusRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: PortsStatusRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): PortsStatusRequest;
  static deserializeBinaryFromReader(message: PortsStatusRequest, reader: jspb.BinaryReader): PortsStatusRequest;
}

export namespace PortsStatusRequest {
  export type AsObject = {
    observe: boolean,
  }
}

export class PortsStatusResponse extends jspb.Message {
  clearPortsList(): void;
  getPortsList(): Array<PortsStatus>;
  setPortsList(value: Array<PortsStatus>): void;
  addPorts(value?: PortsStatus, index?: number): PortsStatus;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): PortsStatusResponse.AsObject;
  static toObject(includeInstance: boolean, msg: PortsStatusResponse): PortsStatusResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: PortsStatusResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): PortsStatusResponse;
  static deserializeBinaryFromReader(message: PortsStatusResponse, reader: jspb.BinaryReader): PortsStatusResponse;
}

export namespace PortsStatusResponse {
  export type AsObject = {
    portsList: Array<PortsStatus.AsObject>,
  }
}

export class ExposedPortInfo extends jspb.Message {
  getVisibility(): PortVisibilityMap[keyof PortVisibilityMap];
  setVisibility(value: PortVisibilityMap[keyof PortVisibilityMap]): void;

  getUrl(): string;
  setUrl(value: string): void;

  getOnExposed(): OnPortExposedActionMap[keyof OnPortExposedActionMap];
  setOnExposed(value: OnPortExposedActionMap[keyof OnPortExposedActionMap]): void;

  getProtocol(): PortProtocolMap[keyof PortProtocolMap];
  setProtocol(value: PortProtocolMap[keyof PortProtocolMap]): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ExposedPortInfo.AsObject;
  static toObject(includeInstance: boolean, msg: ExposedPortInfo): ExposedPortInfo.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ExposedPortInfo, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ExposedPortInfo;
  static deserializeBinaryFromReader(message: ExposedPortInfo, reader: jspb.BinaryReader): ExposedPortInfo;
}

export namespace ExposedPortInfo {
  export type AsObject = {
    visibility: PortVisibilityMap[keyof PortVisibilityMap],
    url: string,
    onExposed: OnPortExposedActionMap[keyof OnPortExposedActionMap],
    protocol: PortProtocolMap[keyof PortProtocolMap],
  }
}

export class TunneledPortInfo extends jspb.Message {
  getTargetPort(): number;
  setTargetPort(value: number): void;

  getVisibility(): port_pb.TunnelVisiblityMap[keyof port_pb.TunnelVisiblityMap];
  setVisibility(value: port_pb.TunnelVisiblityMap[keyof port_pb.TunnelVisiblityMap]): void;

  getClientsMap(): jspb.Map<string, number>;
  clearClientsMap(): void;
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): TunneledPortInfo.AsObject;
  static toObject(includeInstance: boolean, msg: TunneledPortInfo): TunneledPortInfo.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: TunneledPortInfo, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): TunneledPortInfo;
  static deserializeBinaryFromReader(message: TunneledPortInfo, reader: jspb.BinaryReader): TunneledPortInfo;
}

export namespace TunneledPortInfo {
  export type AsObject = {
    targetPort: number,
    visibility: port_pb.TunnelVisiblityMap[keyof port_pb.TunnelVisiblityMap],
    clientsMap: Array<[string, number]>,
  }
}

export class PortsStatus extends jspb.Message {
  getLocalPort(): number;
  setLocalPort(value: number): void;

  getServed(): boolean;
  setServed(value: boolean): void;

  hasExposed(): boolean;
  clearExposed(): void;
  getExposed(): ExposedPortInfo | undefined;
  setExposed(value?: ExposedPortInfo): void;

  getAutoExposure(): PortAutoExposureMap[keyof PortAutoExposureMap];
  setAutoExposure(value: PortAutoExposureMap[keyof PortAutoExposureMap]): void;

  hasTunneled(): boolean;
  clearTunneled(): void;
  getTunneled(): TunneledPortInfo | undefined;
  setTunneled(value?: TunneledPortInfo): void;

  getDescription(): string;
  setDescription(value: string): void;

  getName(): string;
  setName(value: string): void;

  getOnOpen(): PortsStatus.OnOpenActionMap[keyof PortsStatus.OnOpenActionMap];
  setOnOpen(value: PortsStatus.OnOpenActionMap[keyof PortsStatus.OnOpenActionMap]): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): PortsStatus.AsObject;
  static toObject(includeInstance: boolean, msg: PortsStatus): PortsStatus.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: PortsStatus, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): PortsStatus;
  static deserializeBinaryFromReader(message: PortsStatus, reader: jspb.BinaryReader): PortsStatus;
}

export namespace PortsStatus {
  export type AsObject = {
    localPort: number,
    served: boolean,
    exposed?: ExposedPortInfo.AsObject,
    autoExposure: PortAutoExposureMap[keyof PortAutoExposureMap],
    tunneled?: TunneledPortInfo.AsObject,
    description: string,
    name: string,
    onOpen: PortsStatus.OnOpenActionMap[keyof PortsStatus.OnOpenActionMap],
  }

  export interface OnOpenActionMap {
    IGNORE: 0;
    OPEN_BROWSER: 1;
    OPEN_PREVIEW: 2;
    NOTIFY: 3;
    NOTIFY_PRIVATE: 4;
  }

  export const OnOpenAction: OnOpenActionMap;
}

export class TasksStatusRequest extends jspb.Message {
  getObserve(): boolean;
  setObserve(value: boolean): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): TasksStatusRequest.AsObject;
  static toObject(includeInstance: boolean, msg: TasksStatusRequest): TasksStatusRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: TasksStatusRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): TasksStatusRequest;
  static deserializeBinaryFromReader(message: TasksStatusRequest, reader: jspb.BinaryReader): TasksStatusRequest;
}

export namespace TasksStatusRequest {
  export type AsObject = {
    observe: boolean,
  }
}

export class TasksStatusResponse extends jspb.Message {
  clearTasksList(): void;
  getTasksList(): Array<TaskStatus>;
  setTasksList(value: Array<TaskStatus>): void;
  addTasks(value?: TaskStatus, index?: number): TaskStatus;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): TasksStatusResponse.AsObject;
  static toObject(includeInstance: boolean, msg: TasksStatusResponse): TasksStatusResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: TasksStatusResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): TasksStatusResponse;
  static deserializeBinaryFromReader(message: TasksStatusResponse, reader: jspb.BinaryReader): TasksStatusResponse;
}

export namespace TasksStatusResponse {
  export type AsObject = {
    tasksList: Array<TaskStatus.AsObject>,
  }
}

export class TaskStatus extends jspb.Message {
  getId(): string;
  setId(value: string): void;

  getState(): TaskStateMap[keyof TaskStateMap];
  setState(value: TaskStateMap[keyof TaskStateMap]): void;

  getTerminal(): string;
  setTerminal(value: string): void;

  hasPresentation(): boolean;
  clearPresentation(): void;
  getPresentation(): TaskPresentation | undefined;
  setPresentation(value?: TaskPresentation): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): TaskStatus.AsObject;
  static toObject(includeInstance: boolean, msg: TaskStatus): TaskStatus.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: TaskStatus, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): TaskStatus;
  static deserializeBinaryFromReader(message: TaskStatus, reader: jspb.BinaryReader): TaskStatus;
}

export namespace TaskStatus {
  export type AsObject = {
    id: string,
    state: TaskStateMap[keyof TaskStateMap],
    terminal: string,
    presentation?: TaskPresentation.AsObject,
  }
}

export class TaskPresentation extends jspb.Message {
  getName(): string;
  setName(value: string): void;

  getOpenIn(): string;
  setOpenIn(value: string): void;

  getOpenMode(): string;
  setOpenMode(value: string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): TaskPresentation.AsObject;
  static toObject(includeInstance: boolean, msg: TaskPresentation): TaskPresentation.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: TaskPresentation, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): TaskPresentation;
  static deserializeBinaryFromReader(message: TaskPresentation, reader: jspb.BinaryReader): TaskPresentation;
}

export namespace TaskPresentation {
  export type AsObject = {
    name: string,
    openIn: string,
    openMode: string,
  }
}

export class ResourcesStatuRequest extends jspb.Message {
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ResourcesStatuRequest.AsObject;
  static toObject(includeInstance: boolean, msg: ResourcesStatuRequest): ResourcesStatuRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ResourcesStatuRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ResourcesStatuRequest;
  static deserializeBinaryFromReader(message: ResourcesStatuRequest, reader: jspb.BinaryReader): ResourcesStatuRequest;
}

export namespace ResourcesStatuRequest {
  export type AsObject = {
  }
}

export class ResourcesStatusResponse extends jspb.Message {
  hasMemory(): boolean;
  clearMemory(): void;
  getMemory(): ResourceStatus | undefined;
  setMemory(value?: ResourceStatus): void;

  hasCpu(): boolean;
  clearCpu(): void;
  getCpu(): ResourceStatus | undefined;
  setCpu(value?: ResourceStatus): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ResourcesStatusResponse.AsObject;
  static toObject(includeInstance: boolean, msg: ResourcesStatusResponse): ResourcesStatusResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ResourcesStatusResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ResourcesStatusResponse;
  static deserializeBinaryFromReader(message: ResourcesStatusResponse, reader: jspb.BinaryReader): ResourcesStatusResponse;
}

export namespace ResourcesStatusResponse {
  export type AsObject = {
    memory?: ResourceStatus.AsObject,
    cpu?: ResourceStatus.AsObject,
  }
}

export class ResourceStatus extends jspb.Message {
  getUsed(): number;
  setUsed(value: number): void;

  getLimit(): number;
  setLimit(value: number): void;

  getSeverity(): ResourceStatusSeverityMap[keyof ResourceStatusSeverityMap];
  setSeverity(value: ResourceStatusSeverityMap[keyof ResourceStatusSeverityMap]): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ResourceStatus.AsObject;
  static toObject(includeInstance: boolean, msg: ResourceStatus): ResourceStatus.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ResourceStatus, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ResourceStatus;
  static deserializeBinaryFromReader(message: ResourceStatus, reader: jspb.BinaryReader): ResourceStatus;
}

export namespace ResourceStatus {
  export type AsObject = {
    used: number,
    limit: number,
    severity: ResourceStatusSeverityMap[keyof ResourceStatusSeverityMap],
  }
}

export interface ContentSourceMap {
  FROM_OTHER: 0;
  FROM_BACKUP: 1;
  FROM_PREBUILD: 2;
}

export const ContentSource: ContentSourceMap;

export interface PortVisibilityMap {
  PRIVATE: 0;
  PUBLIC: 1;
}

export const PortVisibility: PortVisibilityMap;

export interface PortProtocolMap {
  HTTP: 0;
  HTTPS: 1;
}

export const PortProtocol: PortProtocolMap;

export interface OnPortExposedActionMap {
  IGNORE: 0;
  OPEN_BROWSER: 1;
  OPEN_PREVIEW: 2;
  NOTIFY: 3;
  NOTIFY_PRIVATE: 4;
}

export const OnPortExposedAction: OnPortExposedActionMap;

export interface PortAutoExposureMap {
  TRYING: 0;
  SUCCEEDED: 1;
  FAILED: 2;
}

export const PortAutoExposure: PortAutoExposureMap;

export interface TaskStateMap {
  OPENING: 0;
  RUNNING: 1;
  CLOSED: 2;
}

export const TaskState: TaskStateMap;

export interface ResourceStatusSeverityMap {
  NORMAL: 0;
  WARNING: 1;
  DANGER: 2;
}

export const ResourceStatusSeverity: ResourceStatusSeverityMap;

