// package: supervisor
// file: terminal.proto

import * as terminal_pb from "./terminal_pb";
import {grpc} from "@improbable-eng/grpc-web";

type TerminalServiceOpen = {
  readonly methodName: string;
  readonly service: typeof TerminalService;
  readonly requestStream: false;
  readonly responseStream: false;
  readonly requestType: typeof terminal_pb.OpenTerminalRequest;
  readonly responseType: typeof terminal_pb.OpenTerminalResponse;
};

type TerminalServiceShutdown = {
  readonly methodName: string;
  readonly service: typeof TerminalService;
  readonly requestStream: false;
  readonly responseStream: false;
  readonly requestType: typeof terminal_pb.ShutdownTerminalRequest;
  readonly responseType: typeof terminal_pb.ShutdownTerminalResponse;
};

type TerminalServiceGet = {
  readonly methodName: string;
  readonly service: typeof TerminalService;
  readonly requestStream: false;
  readonly responseStream: false;
  readonly requestType: typeof terminal_pb.GetTerminalRequest;
  readonly responseType: typeof terminal_pb.Terminal;
};

type TerminalServiceList = {
  readonly methodName: string;
  readonly service: typeof TerminalService;
  readonly requestStream: false;
  readonly responseStream: false;
  readonly requestType: typeof terminal_pb.ListTerminalsRequest;
  readonly responseType: typeof terminal_pb.ListTerminalsResponse;
};

type TerminalServiceListen = {
  readonly methodName: string;
  readonly service: typeof TerminalService;
  readonly requestStream: false;
  readonly responseStream: true;
  readonly requestType: typeof terminal_pb.ListenTerminalRequest;
  readonly responseType: typeof terminal_pb.ListenTerminalResponse;
};

type TerminalServiceWrite = {
  readonly methodName: string;
  readonly service: typeof TerminalService;
  readonly requestStream: false;
  readonly responseStream: false;
  readonly requestType: typeof terminal_pb.WriteTerminalRequest;
  readonly responseType: typeof terminal_pb.WriteTerminalResponse;
};

type TerminalServiceSetSize = {
  readonly methodName: string;
  readonly service: typeof TerminalService;
  readonly requestStream: false;
  readonly responseStream: false;
  readonly requestType: typeof terminal_pb.SetTerminalSizeRequest;
  readonly responseType: typeof terminal_pb.SetTerminalSizeResponse;
};

type TerminalServiceSetTitle = {
  readonly methodName: string;
  readonly service: typeof TerminalService;
  readonly requestStream: false;
  readonly responseStream: false;
  readonly requestType: typeof terminal_pb.SetTerminalTitleRequest;
  readonly responseType: typeof terminal_pb.SetTerminalTitleResponse;
};

type TerminalServiceUpdateAnnotations = {
  readonly methodName: string;
  readonly service: typeof TerminalService;
  readonly requestStream: false;
  readonly responseStream: false;
  readonly requestType: typeof terminal_pb.UpdateTerminalAnnotationsRequest;
  readonly responseType: typeof terminal_pb.UpdateTerminalAnnotationsResponse;
};

export class TerminalService {
  static readonly serviceName: string;
  static readonly Open: TerminalServiceOpen;
  static readonly Shutdown: TerminalServiceShutdown;
  static readonly Get: TerminalServiceGet;
  static readonly List: TerminalServiceList;
  static readonly Listen: TerminalServiceListen;
  static readonly Write: TerminalServiceWrite;
  static readonly SetSize: TerminalServiceSetSize;
  static readonly SetTitle: TerminalServiceSetTitle;
  static readonly UpdateAnnotations: TerminalServiceUpdateAnnotations;
}

export type ServiceError = { message: string, code: number; metadata: grpc.Metadata }
export type Status = { details: string, code: number; metadata: grpc.Metadata }

interface UnaryResponse {
  cancel(): void;
}
interface ResponseStream<T> {
  cancel(): void;
  on(type: 'data', handler: (message: T) => void): ResponseStream<T>;
  on(type: 'end', handler: (status?: Status) => void): ResponseStream<T>;
  on(type: 'status', handler: (status: Status) => void): ResponseStream<T>;
}
interface RequestStream<T> {
  write(message: T): RequestStream<T>;
  end(): void;
  cancel(): void;
  on(type: 'end', handler: (status?: Status) => void): RequestStream<T>;
  on(type: 'status', handler: (status: Status) => void): RequestStream<T>;
}
interface BidirectionalStream<ReqT, ResT> {
  write(message: ReqT): BidirectionalStream<ReqT, ResT>;
  end(): void;
  cancel(): void;
  on(type: 'data', handler: (message: ResT) => void): BidirectionalStream<ReqT, ResT>;
  on(type: 'end', handler: (status?: Status) => void): BidirectionalStream<ReqT, ResT>;
  on(type: 'status', handler: (status: Status) => void): BidirectionalStream<ReqT, ResT>;
}

export class TerminalServiceClient {
  readonly serviceHost: string;

  constructor(serviceHost: string, options?: grpc.RpcOptions);
  open(
    requestMessage: terminal_pb.OpenTerminalRequest,
    metadata: grpc.Metadata,
    callback: (error: ServiceError|null, responseMessage: terminal_pb.OpenTerminalResponse|null) => void
  ): UnaryResponse;
  open(
    requestMessage: terminal_pb.OpenTerminalRequest,
    callback: (error: ServiceError|null, responseMessage: terminal_pb.OpenTerminalResponse|null) => void
  ): UnaryResponse;
  shutdown(
    requestMessage: terminal_pb.ShutdownTerminalRequest,
    metadata: grpc.Metadata,
    callback: (error: ServiceError|null, responseMessage: terminal_pb.ShutdownTerminalResponse|null) => void
  ): UnaryResponse;
  shutdown(
    requestMessage: terminal_pb.ShutdownTerminalRequest,
    callback: (error: ServiceError|null, responseMessage: terminal_pb.ShutdownTerminalResponse|null) => void
  ): UnaryResponse;
  get(
    requestMessage: terminal_pb.GetTerminalRequest,
    metadata: grpc.Metadata,
    callback: (error: ServiceError|null, responseMessage: terminal_pb.Terminal|null) => void
  ): UnaryResponse;
  get(
    requestMessage: terminal_pb.GetTerminalRequest,
    callback: (error: ServiceError|null, responseMessage: terminal_pb.Terminal|null) => void
  ): UnaryResponse;
  list(
    requestMessage: terminal_pb.ListTerminalsRequest,
    metadata: grpc.Metadata,
    callback: (error: ServiceError|null, responseMessage: terminal_pb.ListTerminalsResponse|null) => void
  ): UnaryResponse;
  list(
    requestMessage: terminal_pb.ListTerminalsRequest,
    callback: (error: ServiceError|null, responseMessage: terminal_pb.ListTerminalsResponse|null) => void
  ): UnaryResponse;
  listen(requestMessage: terminal_pb.ListenTerminalRequest, metadata?: grpc.Metadata): ResponseStream<terminal_pb.ListenTerminalResponse>;
  write(
    requestMessage: terminal_pb.WriteTerminalRequest,
    metadata: grpc.Metadata,
    callback: (error: ServiceError|null, responseMessage: terminal_pb.WriteTerminalResponse|null) => void
  ): UnaryResponse;
  write(
    requestMessage: terminal_pb.WriteTerminalRequest,
    callback: (error: ServiceError|null, responseMessage: terminal_pb.WriteTerminalResponse|null) => void
  ): UnaryResponse;
  setSize(
    requestMessage: terminal_pb.SetTerminalSizeRequest,
    metadata: grpc.Metadata,
    callback: (error: ServiceError|null, responseMessage: terminal_pb.SetTerminalSizeResponse|null) => void
  ): UnaryResponse;
  setSize(
    requestMessage: terminal_pb.SetTerminalSizeRequest,
    callback: (error: ServiceError|null, responseMessage: terminal_pb.SetTerminalSizeResponse|null) => void
  ): UnaryResponse;
  setTitle(
    requestMessage: terminal_pb.SetTerminalTitleRequest,
    metadata: grpc.Metadata,
    callback: (error: ServiceError|null, responseMessage: terminal_pb.SetTerminalTitleResponse|null) => void
  ): UnaryResponse;
  setTitle(
    requestMessage: terminal_pb.SetTerminalTitleRequest,
    callback: (error: ServiceError|null, responseMessage: terminal_pb.SetTerminalTitleResponse|null) => void
  ): UnaryResponse;
  updateAnnotations(
    requestMessage: terminal_pb.UpdateTerminalAnnotationsRequest,
    metadata: grpc.Metadata,
    callback: (error: ServiceError|null, responseMessage: terminal_pb.UpdateTerminalAnnotationsResponse|null) => void
  ): UnaryResponse;
  updateAnnotations(
    requestMessage: terminal_pb.UpdateTerminalAnnotationsRequest,
    callback: (error: ServiceError|null, responseMessage: terminal_pb.UpdateTerminalAnnotationsResponse|null) => void
  ): UnaryResponse;
}

